const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class VendorsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const vendors = await db.vendors.create(
      {
        id: data.id || undefined,

        vendor_name: data.vendor_name || null,
        contact_email: data.contact_email || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await vendors.setCompanies(data.companies || null, {
      transaction,
    });

    await vendors.setPurchase_orders(data.purchase_orders || [], {
      transaction,
    });

    return vendors;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const vendorsData = data.map((item, index) => ({
      id: item.id || undefined,

      vendor_name: item.vendor_name || null,
      contact_email: item.contact_email || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const vendors = await db.vendors.bulkCreate(vendorsData, { transaction });

    // For each item created, replace relation files

    return vendors;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const vendors = await db.vendors.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.vendor_name !== undefined)
      updatePayload.vendor_name = data.vendor_name;

    if (data.contact_email !== undefined)
      updatePayload.contact_email = data.contact_email;

    updatePayload.updatedById = currentUser.id;

    await vendors.update(updatePayload, { transaction });

    if (data.companies !== undefined) {
      await vendors.setCompanies(
        data.companies,

        { transaction },
      );
    }

    if (data.purchase_orders !== undefined) {
      await vendors.setPurchase_orders(data.purchase_orders, { transaction });
    }

    return vendors;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const vendors = await db.vendors.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of vendors) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of vendors) {
        await record.destroy({ transaction });
      }
    });

    return vendors;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const vendors = await db.vendors.findByPk(id, options);

    await vendors.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await vendors.destroy({
      transaction,
    });

    return vendors;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const vendors = await db.vendors.findOne({ where }, { transaction });

    if (!vendors) {
      return vendors;
    }

    const output = vendors.get({ plain: true });

    output.purchase_orders_vendor = await vendors.getPurchase_orders_vendor({
      transaction,
    });

    output.purchase_orders = await vendors.getPurchase_orders({
      transaction,
    });

    output.companies = await vendors.getCompanies({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userCompanies = (user && user.companies?.id) || null;

    if (userCompanies) {
      if (options?.currentUser?.companiesId) {
        where.companiesId = options.currentUser.companiesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.companies,
        as: 'companies',
      },

      {
        model: db.purchase_orders,
        as: 'purchase_orders',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.vendor_name) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('vendors', 'vendor_name', filter.vendor_name),
        };
      }

      if (filter.contact_email) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'vendors',
            'contact_email',
            filter.contact_email,
          ),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.companies) {
        const listItems = filter.companies.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          companiesId: { [Op.or]: listItems },
        };
      }

      if (filter.purchase_orders) {
        const searchTerms = filter.purchase_orders.split('|');

        include = [
          {
            model: db.purchase_orders,
            as: 'purchase_orders_filter',
            required: searchTerms.length > 0,
            where:
              searchTerms.length > 0
                ? {
                    [Op.or]: [
                      {
                        id: {
                          [Op.in]: searchTerms.map((term) => Utils.uuid(term)),
                        },
                      },
                      {
                        total_cost: {
                          [Op.or]: searchTerms.map((term) => ({
                            [Op.iLike]: `%${term}%`,
                          })),
                        },
                      },
                    ],
                  }
                : undefined,
          },
          ...include,
        ];
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.companiesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.vendors.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('vendors', 'vendor_name', query),
        ],
      };
    }

    const records = await db.vendors.findAll({
      attributes: ['id', 'vendor_name'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['vendor_name', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.vendor_name,
    }));
  }
};
